--[[ Loggin

     Start non-combat logging

]]--

local addoninfo, log = ...
local ls = Library.LibSession
local printf = Library.printf.printf

local display_stamp

local function in_a_bit()
  local now = Inspect.Time.Frame()
  if (now - display_stamp) > 0.5 then
    Command.Event.Detach(Event.System.Update.Begin, in_a_bit)
    printf("Date: %s (caveat: Date is local time, chat log timestamps may be UTC.)", os.date("%Y-%m-%d"))
  end
end

local function clear_button()
  if log.button then
    log.button:SetVisible(false)
    log.button:SetEnabled(false)
    display_stamp = Inspect.Time.Frame()
    Command.Event.Attach(Event.System.Update.Begin, in_a_bit, "display something shortly")
  end
end

local function maybe_log(do_it)
  if do_it then
    log.context = UI.CreateContext('Loggin')
    log.context:SetStrata('dialog')
    log.context:SetSecureMode("restricted")
    log.button = UI.CreateFrame('RiftButton', 'loggin non-combat log button', log.context)
    log.button:SetVisible(false)
    log.button:SetText("Start Logging?")
    log.button:SetPoint("CENTER", UIParent, "CENTER")
    log.button:SetSecureMode("restricted")
    log.button:SetWidth(450)
    log.button:SetHeight(120)
    log.button:EventMacroSet(Event.UI.Input.Mouse.Left.Click, "log")
    log.button:EventAttach(Event.UI.Input.Mouse.Left.Click, clear_button, "clear the button")
    log.button:EventAttach(Event.UI.Input.Mouse.Right.Click, clear_button, "clear the button")
    log.button:SetVisible(true)
    printf("Looks like a new session.")
  else
    printf("Not a new session. Non-combat log probably already enabled.")
    printf("Date: %s (caveat: Date is local time, chat log timestamps may be UTC.)", os.date("%Y-%m-%d"))
  end
end

ls.session_status(maybe_log)
